<?php
//информация по wmid
define('GIX_SU_USINFO', 'http://gix.su/api/userinfo.php');
//магазин
define('GIX_SU_ALLSHOP', 'http://gix.su/api/shop/shop.php');
//магазин пользователя
define('GIX_SU_MYSHOP', 'http://gix.su/api/shop/my_shop.php');
//форма оплаты
define('GIX_SU_PAYMENT', 'http://gix.su/api/shop/payment.php');
//количество товаров продавца
define('GIX_SU_COUNT', 'http://gix.su/api/shop/count.php');

class GixSuApi {


     static $device = 'mobile';

          function __construct()
          { 

          self::get('Mobile_Detect');
          $detect = new Mobile_Detect;
          self::$device = $detect->isMobile() ? 'phone' : 'computer';

          }


          static function get($file)
          {
          global $shop_path;
               if (is_array($file))
               {
                    foreach($file as $file)
                    {
                    self::get($file);
                    }
               }
               elseif (file_exists($_SERVER['DOCUMENT_ROOT'].''.$shop_path.'inc/classes/'.$file.'.class.php'))
               {
               include_once $_SERVER['DOCUMENT_ROOT'].''.$shop_path.'inc/classes/'.$file.'.class.php';
               }
          }



    //Поиск 
    static function search($str) {
        $str = urlencode($str);
        $content = self::http(GIX_SU_USINFO . '?search=' . $str);
        $arr = unserialize($content);
        return $arr;
    }

     //Магазин
     static function all_shop($str_arr) {
        $content = self::http(GIX_SU_ALLSHOP . '?' . $str_arr);
        $arr = unserialize($content);
        return $arr;
    }


     //Магазин юзера
     static function my_shop($str_arr) {
        $content = self::http(GIX_SU_MYSHOP . '?' . $str_arr);
        $arr = unserialize($content);
        return $arr;
    }


     //Форма оплаты товара
     static function payment($str_arr) {
        $content = self::http(GIX_SU_PAYMENT . '?' . $str_arr);
        $arr = unserialize($content);
        return $arr;
    }


     static function my_count($str) {
        $content = self::http(GIX_SU_COUNT . '?' . $str);
        $arr = unserialize($content);
        return $arr;
    }



    //Запрос по http
    static function http($url, $headers = Array(), $post_array = Array()) {

        if (!function_exists('curl_init')) {
            return file_get_contents($url);
        }

        $head = Array();
        if (is_array($headers)) {
            foreach ($headers AS $key => $val) {
                $head[] = $key . ': ' . $val;
            }
        }

        $post = '';
        if ($post_array) {
            $c = count($post_array);
            $i = 0;
            foreach ($post_array AS $key => $val) {
                $i++;
                $post.= $key . '=' . $val;
                if ($i <> $c) {
                    $post .= '&';
                }
            }
        }


        $ch = curl_init();
        curl_setopt($ch, CURLOPT_PROGRESSFUNCTION, 'gix_curl_pb_callback');      //Функция для ограничения трафика по размеру
        curl_setopt($ch, CURLOPT_NOPROGRESS, false);

        if ($post) {
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        }

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)');

        if ($head){
            curl_setopt($ch, CURLOPT_HTTPHEADER, $head);  //Заголовки
        }



            
//curl_setopt($ch, CURLOPT_HEADER,         true);         // для включения заголовков в вывод.
        //curl_setopt($ch, CURLOPT_NOBODY,         true);         // для исключения тела ответа из вывода. Метод запроса устанавливается в HEAD. 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);           //Количество секунд ожидания при попытке соединения    
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);           //Максимально позволенное количество секунд для выполнения cURL-функций.
        //curl_setopt($ch, CURLINFO_HEADER_OUT,        true);

        $result = curl_exec($ch);

        //print_r(curl_getinfo ($ch ,CURLINFO_HEADER_OUT));
        //Возвращаем false, устанавливаем сообщение об ошибке----
        $err = curl_error($ch);
        if ($err) {
            throw new Exception($err);
        }
        //-------------------------------------------------------

        curl_close($ch);

        return $result;
    }

}

//call back функция для curl, ограничивает размер скачиваемого файла
function gix_curl_pb_callback($download_size, $downloaded, $upload_size, $uploaded) {
    global $ch;
    static $summ;
    if (!isset($summ)) {
        $summ = 0;
    }
    $summ+=$downloaded;
    if ($summ > 500 * 1024) {
        throw new Exception('Too long content');
    }
    return false;
}

//----------------------------------------------------------------
?>
