<?php

    Class View
    {


        /**
         * Вывод сообщений. Аналог msg() и err()
         * @param $msg (mixed) выводимое сообщение. Может быть массивом или строкой
         * @param $div (string) класс div'а. 
         */

        static function msg_show($msg, $div = 'error')
        {
            if (is_array($msg))
            {
                foreach($msg as $msg)
                {
                    echo '<div class="'.$div.'">'.$msg.'</div>';
                }
            }
            else
                echo '<div class="'.$div.'">'.$msg.'</div>';
        }



     static function pagination($link = '?', $k_page=1, $page = 1, $div = 'str')
     { // Вывод номеров страниц

          if ($page < 1)$page = 1;

     echo '<div class="'.$div.'">';

          if ($page != 1)echo '<a href="'.$link.'page=1" title="Первая страница">&lt;&lt;</a> ';

          if ($page > 1)echo '<a href="'.$link.'page='.($page - 1).'" title="Предыдущая страница (№'.($page-1).')">&lt;</a> ';

     echo ' ';

          if ($page < $k_page)echo ' <a href="'.$link.'page='.($page+1).'" title="Следующая страница (№'.($page+1).')">&gt;</a>';

          if ($page != $k_page)echo ' <a href="'.$link.'page=end" title="Последняя страница">&gt;&gt;</a>';

      echo '<br />';

          if ($page != 1)echo '<a href="'.$link.'page=1" title="Страница №1">1</a>';
          else echo '<b>1</b>';

          for ($ot = -3; $ot <= 3; $ot++)
          {

               if ($page + $ot > 1 && $page + $ot < $k_page)
               {
                    if ($ot == -3 && $page + $ot > 2)echo ' ..';
                    if ($ot != 0)echo ' <a href="'.$link.'page='.($page + $ot).'" title="Страница №'.($page+$ot).'">'.($page + $ot).'</a>';
                    else echo ' <b>'.($page + $ot).'</b>';
                    if ($ot == 3 && $page + $ot < $k_page - 1)echo ' ..';
               }
          }

          if ($page != $k_page)echo ' <a href="'.$link.'page=end" title="Страница №'.$k_page.'">'.$k_page.'</a>';
          elseif ($k_page > 1)echo ' <b>'.$k_page.'</b>';

     echo '</div>';

     }
        


        static function output($str, $set = array('html' => true, 'links' => true, 'bbcode' => true, 'smiles' => true, 'br' => true))
        {
            if ($set['html'])
                $str = htmlspecialchars($str);

            if ($set['links'])
                $str = self::links($str);

            if ($set['bbcode'])
            {
                $tmp_str = $str;
                $str = self::bbcode($str);
            }

            if ($set['smiles'] && $tmp_str == $str)
                $str = self::smiles($str);

            if ($set['br'])
            {
                $str = nl2br($str);
            }

     return $str;
     }


     static function StrLink_($args) 
     {
          if(strpos($args[0], ']'))return $args[0];
          elseif(strpos($args[0], 'http'))return $args[0];
          elseif(strpos($args[0], '@'))return $args[0];
          elseif (strpos($args[0], 'mailto'))return $args[0];
          else return '<a href="http://'.$args[2].'.'.$args[3].''.$args[4].'">'.$args[2].'.'.$args[3].''.$args[4].'</a>';
     }

     static function Email($arr) 
     {
     return '<a href="mailto:'.$arr[0].'">'.$arr[0].'</a>';
     }
     static function smiles($msg)
     {

$msg = preg_replace('#(:|=)-?\){4,}|:ROFL:|\*ROFL\*|ROFL!{1,}#i', '<img src="http://st.gix.su/style/smiles/rofl.gif" alt="*ROFL*" />', $msg);
$msg = preg_replace('#\*БРАВО\*|:БРАВО:|:clapping:|:BRAVO:|\*BRAVO\*#iu', '<img src="http://st.gix.su/style/smiles/clapping.gif" alt="Браво" />', $msg);
// большая улыбка
$msg = preg_replace('#((:-?)|\+|=)D#', '<img src="http://st.gix.su/style/smiles/biggrin.gif" alt="\\0" />', $msg);
//
$msg = preg_replace('#\*TIRED\*|\|-?0|:boredom:#i', '<img src="http://st.gix.su/style/smiles/boredom.gif" alt="*TIRED*" />', $msg);
// плохо
$msg = preg_replace('#:-?(!|~)|:bad:|(:|\+|=)\(~#i', '<img src="http://st.gix.su/style/smiles/bad.gif" alt=":-!" />', $msg);
// улыбка 
$msg = preg_replace('#(:-?|\+)\){1,3}|:smile:|\*smile\*#i', '<img src="http://st.gix.su/style/smiles/smile.gif" alt="\\0" />', $msg);
// грусть
$msg = preg_replace('#(:-?|\+)\({1,3}|:sad:|\*sad\*#i', '<img src="http://st.gix.su/style/smiles/sad.gif" alt="\\0" />', $msg);
// подмигивание
$msg = preg_replace('#(^| );-?\)#', '<img src="http://st.gix.su/style/smiles/wink.gif" alt="\\0" />', $msg);
$msg = str_replace('^_~', '<img src="http://st.gix.su/style/smiles/wink.gif" alt="^_~" />', $msg);
$msg = preg_replace('#:wink:#i', '<img src="http://st.gix.su/style/smiles/wink.gif" alt=":wink:" />', $msg);
// язык 
$msg = preg_replace('#(:-?)(P|b|p)#', '<img src="http://st.gix.su/style/smiles/blum3.gif" alt="\\0" />', $msg);
$msg = preg_replace('#:tongue:#i', '<img src="http://st.gix.su/style/smiles/blum3.gif" alt=":tongue:" />', $msg);
// крутой
$msg = preg_replace('#((8|B)-?)\)#', '<img src="http://st.gix.su/style/smiles/dirol.gif" alt="\\0" />', $msg);
$msg = preg_replace('#:COOL:|COOL!{1,}#i', '<img src="http://st.gix.su/style/smiles/dirol.gif" alt="\\0" />', $msg);

// 
$msg = str_replace(':-[', '<img src="http://st.gix.su/style/smiles/blush2.gif" alt=":-[" />', $msg);
// шок
$msg = preg_replace('#(O|0)_(O|0)#i', '<img src="http://st.gix.su/style/smiles/shok.gif" alt="\\0" />', $msg);
// поцелуй
$msg = preg_replace('#(:-?)(\*|\{\})|\^\.\^|:kiss:|\*kiss\*#i', '<img src="http://st.gix.su/style/smiles/kiss.gif" alt="\\0" />', $msg);
// плак
$msg = preg_replace('#:\'-?\({1,}#', '<img src="http://st.gix.su/style/smiles/cray.gif" alt="\\0" />', $msg);
// секрет
$msg = preg_replace('#:-?(X|\#)|:secret:#i', '<img src="http://st.gix.su/style/smiles/secret.gif" alt="\\0" />', $msg);
// агрессия
$msg = preg_replace('#(&gt;)(:|\+)(o|0)|:angry:|:-@#i', '<img src="http://st.gix.su/style/smiles/aggressive.gif" alt="\\0" />', $msg);
// дурак
$msg = preg_replace('#(:-?|=)\|#', '<img src="http://st.gix.su/style/smiles/fool.gif" alt="\\0" />', $msg);
// be
$msg = str_replace(':-/', '<img src="http://st.gix.su/style/smiles/beee.gif" alt="\\0" />', $msg);
// смех
$msg = preg_replace('#\*JOKINGLY\*#i', '<img src="http://st.gix.su/style/smiles/mosking.gif" alt="\\0" />', $msg);
// дьявол
$msg = preg_replace('#\*facepalm\*#i', '<img src="http://st.gix.su/style/smiles/facepalm.gif" alt="\\0" />', $msg);
// facepalm
$msg = preg_replace('#(\]|\}):-?&gt;|:diablo:|\*DIABLO\*|&gt;:-?]#i', '<img src="http://st.gix.su/style/smiles/diablo.gif" alt="\\0" />', $msg);
// музыка
$msg = preg_replace('#\[:-?\}#', '<img src="http://st.gix.su/style/smiles/music2.gif" alt="\\0" />', $msg);
// воздушный поцелуй
$msg = preg_replace('#\*KISSED\*#i', '<img src="http://st.gix.su/style/smiles/air_kiss.gif" alt="\\0" />', $msg);
// стоп
$msg = preg_replace('#\*STOP\*|:stop:|stop!{1,}#i', '<img src="http://st.gix.su/style/smiles/stop.gif" alt="\\0" />', $msg);
// поцелуй
$msg = preg_replace('#\*KISSING\*#i', '<img src="http://st.gix.su/style/smiles/kiss_3.gif" alt="\\0" />', $msg);
// роза
$msg = preg_replace('#@\}-&gt;--|@\}-:--|@&gt;\}--#', '<img src="http://st.gix.su/style/smiles/give_rose.gif" alt="\\0" />', $msg);
// все отлично
$msg = preg_replace('#\*THUMBS_UP\*|:GOOD:|\*GOOD\*|good!{1,}#i', '<img src="http://st.gix.su/style/smiles/good.gif" alt="\\0" />', $msg);
// пить
$msg = preg_replace('#\*DRINK\*|:drink:#i', '<img src="http://st.gix.su/style/smiles/drinks.gif" alt="\\0" />', $msg);
// влюблен
$msg = preg_replace('#\*IN_LOVE\*|LOVE!{1,}#i', '<img src="http://st.gix.su/style/smiles/man_in_love.gif" alt="\\0" />', $msg);
// бомба
$msg = str_replace('@=', '<img src="http://st.gix.su/style/smiles/bomb.gif" alt="@=" />', $msg);
// потерян
$msg = preg_replace('#%-?\)|:-?\$|:wacko:#i', '<img src="http://st.gix.su/style/smiles/wacko.gif" alt="\\0" />', $msg);

$msg = preg_replace('#\*WASSUP\*|\*SUP\*|\*MAMBA\*|:MAMBA:#i', '<img src="http://st.gix.su/style/smiles/mamba.gif" alt="*WASSUP*" />', $msg);

$msg = preg_replace('#\*PARDON\*|:pardon:#i', '<img src="http://st.gix.su/style/smiles/pardon.gif" alt="*PARDON*" />', $msg);


$msg = preg_replace('#\*NO\*#i', '<img src="http://st.gix.su/style/smiles/nea.gif" alt="*NO*" />', $msg);

$msg = preg_replace('#\*CRAZY\*|:crazy:#i', '<img src="http://st.gix.su/style/smiles/crazy.gif" alt="*CRAZY*" />', $msg);

$msg = preg_replace('#\*DONT_KNOW\*|\*UNKNOWN\*|:HZ:#i', '<img src="http://st.gix.su/style/smiles/dntknw.gif" alt="*DONT_KNOW*" />', $msg);

$msg = preg_replace('#\*SORRY\*|:sorry:#i', '<img src="http://st.gix.su/style/smiles/sorry.gif" alt="*SORRY*" />', $msg);

$msg = preg_replace('#\*YAHOO!*\*|:YAHOO:|YAHOO!{1,}#i', '<img src="http://st.gix.su/style/smiles/yahoo.gif" alt="\\0" />', $msg);

$msg = preg_replace('#\*DANCE\*|:dance:#i', '<img src="http://st.gix.su/style/smiles/dance4.gif" alt="*DANCE*" />', $msg);

$msg = preg_replace('#\*HELP\*#i', '<img src="http://st.gix.su/style/smiles/help.gif" alt="*HELP*" />', $msg);

$msg = preg_replace('#\*OK\*#i', '<img src="http://st.gix.su/style/smiles/ok.gif" alt="*OK*" />', $msg);

$msg = preg_replace('#\*HELLO\*|\*PREVED\*|\*PRIVET\*|\*HI\*#i', '<img src="http://st.gix.su/style/smiles/preved.gif" alt="*HELLO*" />', $msg);

$msg = preg_replace('#\*ACUTE\*#i', '<img src="http://st.gix.su/style/smiles/acute.gif" alt="*ACUTE*" />', $msg);

$msg = preg_replace('#\*BYE\*#i', '<img src="http://st.gix.su/style/smiles/bye.gif" alt="*BYE*" />', $msg);

$msg = preg_replace('#\*WRITE\*#i', '<img src="http://st.gix.su/style/smiles/mail1.gif" alt="*WRITE*" />', $msg);
$msg = preg_replace('#\*MAIL\*#i', '<img src="http://st.gix.su/style/smiles/mail1.gif" alt="*MAIL*" />', $msg);

$msg = preg_replace('#\*WALL\*#i', '<img src="http://st.gix.su/style/smiles/dash1.gif" alt="*WALL*" />', $msg);
$msg = preg_replace('#\*DASH\*#i', '<img src="http://st.gix.su/style/smiles/dash1.gif" alt="*DASH*" />', $msg);

$msg = preg_replace('#\*YES\*#i', '<img src="http://st.gix.su/style/smiles/yes3.gif" alt="*YES*" />', $msg);

$msg = preg_replace('#\*SCRATCH\*#i', '<img src="http://st.gix.su/style/smiles/scratch_one-s_head.gif" alt="*SCRATCH*" />', $msg);

$msg = preg_replace('#\*LOL!*\*|:LOL:|LOL!{1,}#i', '<img src="http://st.gix.su/style/smiles/lol.gif" alt="\\0" />', $msg);

$msg = preg_replace('#\*HAPPY\*|:happy:#i', '<img src="http://st.gix.su/style/smiles/i-m_so_happy.gif" alt="*HAPPY*" />', $msg);

$msg = preg_replace('#\*db\*|:db:#i', '<img src="http://st.gix.su/style/smiles/pleasantry.gif" alt="*db*" />', $msg);

     return $msg;

     }

        static function bbcode($msg)
        {
$bbcode=array();
$bbcode['/\[i\](.+)\[\/i\]/isU']='<em>$1</em>';
$bbcode['/\[b\](.+)\[\/b\]/isU']='<strong>$1</strong>';
$bbcode['/\[u\](.+)\[\/u\]/isU']='<span style="text-decoration:underline;">$1</span>';
$bbcode['/\[big\](.+)\[\/big\]/isU']='<span style="font-size:large;">$1</span>';
$bbcode['/\[small\](.+)\[\/small\]/isU']='<span style="font-size:small;">$1</span>';
$bbcode['/\[red\](.+)\[\/red\]/isU']='<span style="color:#ff0000;">$1</span>';
$bbcode['/\[yellow\](.+)\[\/yellow\]/isU']='<span style="color:#ffff22;">$1</span>';
$bbcode['/\[green\](.+)\[\/green\]/isU']='<span style="color:#00bb00;">$1</span>';
$bbcode['/\[blue\](.+)\[\/blue\]/isU']='<span style="color:#0000bb;">$1</span>';
$bbcode['/\[white\](.+)\[\/white\]/isU']='<span style="color:#ffffff;">$1</span>';
$bbcode['/\[size=([0-9]+)\](.+)\[\/size\]/isU']='<span style="font-size:$1px;">$2</span>';

if (count($bbcode))$msg= preg_replace(array_keys($bbcode), array_values($bbcode), $msg);

/*$msg = preg_replace_callback('#&lt;\?(.*?)\?&gt;#sui', 'bbcodehightlight', $msg);*/

$msg = preg_replace('#\[code\](.*?)\[/code\]#si', '\1', $msg);


return $msg;
}

     static function img_preg($arr)
     {
     return '<img src="http://gix.su/go.php?img_url='.urlencode(html_entity_decode($arr[1])).'" alt="img" />';
     }

     static function links_preg1($arr)
     {
     return '<a href="http://gix.su/go.php?ext_url='.urlencode(html_entity_decode($arr[1])).'">'.$arr[2].'</a>';
     }

     static function links_preg2($arr)
     {

          if (preg_match('#^http://'.preg_quote($_SERVER['HTTP_HOST']).'#',$arr[2]))
          return $arr[1].'<a href="'.$arr[2].'">'.$arr[2].'</a>'.$arr[4];
          else
          return $arr[1].'<a href="http://gix.su/go.php?ext_url='.urlencode(html_entity_decode($arr[2])).'">'.$arr[2].'</a>'.$arr[4];

     }







     static function links($msg)
     {

 $dom = array('ru', 'su', 'ua', 'com', 'net', 'biz');
 $msg = preg_replace_callback('#(http:\/\/|)+([A-z0-9\/\.\-]*)\.+('.implode('|',$dom).')+([А-яA-z0-9\/\.\-\_\%\=\&\?]*)#iu', 'View::StrLink_', $msg);

$msg = preg_replace_callback('/\[img\](.+)\[\/img\]/isU', 'View::img_preg', $msg);

$msg = preg_replace_callback('/\[url=(.+)\](.+)\[\/url\]/isU', 'View::links_preg1', $msg); 

$msg = preg_replace_callback('~(^|\s)([a-z]+://([^ \r\n\t`\'"\@]+))(\s|$)~iu', 'View::links_preg2', $msg);

$msg = preg_replace_callback('~[\pL\pN-]+(\.[\pL\pN-]+)*@\pL+(\.[\pL\pN-]+)*\.[\pL]{2,6}~iu', 'View::Email', $msg);

return $msg;
}






}//end View